import uasyncio as asyncio
import machine
import neopixel

class LEDs():
    def __init__(self, pin):
        self.neop = neopixel.NeoPixel(machine.Pin(pin, machine.Pin.OUT),5)
        self.rate = 0
        self.clear()
        loop = asyncio.get_event_loop()
        loop.create_task(self._update_async())

    async def _update_async(self):
        while True:
            if self.rate <= 0:
                await asyncio.sleep_ms(200)
            else:
                self.toggle()
                await asyncio.sleep_ms(int(500 / self.rate))

    def fill(self,color):
        self.neop.fill(color)
        self.neop[0] = (0,0,0)
        self.neop.write()

    def clear(self):
        self.fill((0,0,0))

    def upper(self,color):
        self.neop[3] = color
        self.neop.write()

